e_scroll:

	ldx #0
	
@loop:

	ldy #1
	cpx #5
	bcs :+
	ldy #8
:
	
:
	jsr wait_frame
	dey
	bne :-
	
	txa
	pha
	
	lda #<(SCREEN+0*40)
	sta <Z_DST+0
	lda #>(SCREEN+0*40)
	sta <Z_DST+1
	lda #<(SCREEN+1*40)
	sta <Z_SRC+0
	lda #>(SCREEN+1*40)
	sta <Z_SRC+1
	
	ldx #24
	
@scroll1:
		
	ldy #0
	
	.repeat 40
	lda (Z_SRC),y
	sta (Z_DST),y
	iny
	.endrepeat
	
	lda <Z_SRC+0
	clc
	adc #40
	sta <Z_SRC+0
	bcc :+
	inc <Z_SRC+1
:
	
	lda <Z_DST+0
	clc
	adc #40
	sta <Z_DST+0
	bcc :+
	inc <Z_DST+1
:

	dex
	beq :+
	jmp @scroll1
:
	
	ldy #0
	lda #$20
	
@clear:

	sta SCREEN+24*40,y
	iny
	cpy #40
	bne @clear
	
	pla
	tax
	inx
	cpx #25
	beq :+
	jmp @loop
:
	
	rts