@echo off

set path=%path%;bin\;tools\

del e_scroll.bin
del e_matrix.bin
del e_timeline.bin
del e_title.bin
del e_floor.bin
del e_maze.bin
del e_checkers.bin
del e_checkmate.bin
del e_petflip.bin
del e_waves.bin
del e_greets.bin
del e_morph.bin
del e_bump.bin
del e_voice.bin
del e_noise.bin
del *.zx02
del *.exo
del *.apl
del *.zx0

cl65 -o e_scroll.bin   	-u __EXEHDR__ -t pet -C pet_ex_high2.cfg main_ex_scroll.s
cl65 -o e_matrix.bin   	-u __EXEHDR__ -t pet -C pet_ex_high2.cfg main_ex_matrix.s
cl65 -o e_timeline.bin 	-u __EXEHDR__ -t pet -C pet_ex_high2.cfg main_ex_timeline.s
cl65 -o e_title.bin    	-u __EXEHDR__ -t pet -C pet_ex_high1.cfg main_ex_title.s
cl65 -o e_floor.bin    	-u __EXEHDR__ -t pet -C pet_ex_high1.cfg main_ex_floor.s
cl65 -o e_maze.bin 	-u __EXEHDR__ -t pet -C pet_ex_high1.cfg main_ex_maze.s
cl65 -o e_checkers.bin 	-u __EXEHDR__ -t pet -C pet_ex_high1.cfg main_ex_checkers.s
cl65 -o e_checkmate.bin -u __EXEHDR__ -t pet -C pet_ex_high1.cfg main_ex_checkmate.s
cl65 -o e_petflip.bin 	-u __EXEHDR__ -t pet -C pet_ex.cfg main_ex_petflip.s
cl65 -o e_waves.bin 	-u __EXEHDR__ -t pet -C pet_ex.cfg main_ex_waves.s
cl65 -o e_greets.bin 	-u __EXEHDR__ -t pet -C pet_ex.cfg main_ex_greets.s
cl65 -o e_morph.bin 	-u __EXEHDR__ -t pet -C pet_ex.cfg main_ex_morph.s
cl65 -o e_bump.bin 	-u __EXEHDR__ -t pet -C pet_ex.cfg main_ex_bump.s
cl65 -o e_voice.bin 	-u __EXEHDR__ -t pet -C pet_ex.cfg main_ex_voice.s
cl65 -o e_noise.bin 	-u __EXEHDR__ -t pet -C pet_ex.cfg main_ex_noise.s

zx02 e_matrix.bin e_matrix.zx02
zx02 e_morph.bin e_morph.zx02
zx02 e_petflip.bin e_petflip.zx02
zx02 e_timeline.bin e_timeline.zx02
zx02 e_voice.bin e_voice.zx02
zx02 e_waves.bin e_waves.zx02
zx02 e_bump.bin e_bump.zx02
zx02 e_maze.bin e_maze.zx02
zx02 e_title.bin e_title.zx02
zx02 e_checkers.bin e_checkers.zx02
zx02 e_greets.bin e_greets.zx02
zx02 e_scroll.bin e_scroll.zx02
zx02 e_floor.bin e_floor.zx02
zx02 e_checkmate.bin e_checkmate.zx02
zx02 e_noise.bin e_noise.zx02

REM zx0 e_matrix.bin e_matrix.zx0
REM zx0 e_morph.bin e_morph.zx0
REM zx0 e_petflip.bin e_petflip.zx0
REM zx0 e_timeline.bin e_timeline.zx0
REM zx0 e_voice.bin e_voice.zx0
REM zx0 e_waves.bin e_waves.zx0
REM zx0 e_bump.bin e_bump.zx0
REM zx0 e_maze.bin e_maze.zx0
REM zx0 e_title.bin e_title.zx0
REM zx0 e_checkers.bin e_checkers.zx0
REM zx0 e_greets.bin e_greets.zx0
REM zx0 e_scroll.bin e_scroll.zx0
REM zx0 e_floor.bin e_floor.zx0
REM zx0 e_checkmate.bin e_checkmate.zx0
REM zx0 e_noise.bin e_noise.zx0

REM exomizer raw e_matrix.bin -o e_matrix.exo
REM exomizer raw e_morph.bin -o e_morph.exo
REM exomizer raw e_petflip.bin -o e_petflip.exo
REM exomizer raw e_timeline.bin -o e_timeline.exo
REM exomizer raw e_voice.bin -o e_voice.exo
REM exomizer raw e_waves.bin -o e_waves.exo
REM exomizer raw e_bump.bin -o e_bump.exo
REM exomizer raw e_maze.bin -o e_maze.exo
REM exomizer raw e_title.bin -o e_title.exo
REM exomizer raw e_checkers.bin -o e_checkers.exo
REM exomizer raw e_greets.bin -o e_greets.exo
REM exomizer raw e_scroll.bin -o e_scroll.exo
REM exomizer raw e_floor.bin -o e_floor.exo
REM exomizer raw e_checkmate.bin -o e_checkmate.exo
REM exomizer raw e_noise.bin -o e_noise.exo

REM apultra -c e_matrix.bin e_matrix.apl
REM apultra -c e_morph.bin e_morph.apl
REM apultra -c e_petflip.bin e_petflip.apl
REM apultra -c e_timeline.bin e_timeline.apl
REM apultra -c e_voice.bin e_voice.apl
REM apultra -c e_waves.bin e_waves.apl
REM apultra -c e_bump.bin e_bump.apl
REM apultra -c e_maze.bin e_maze.apl
REM apultra -c e_title.bin e_title.apl
REM apultra -c e_checkers.bin e_checkers.apl
REM apultra -c e_greets.bin e_greets.apl
REM apultra -c e_scroll.bin e_scroll.apl
REM apultra -c e_floor.bin e_floor.apl
REM apultra -c e_checkmate.bin e_checkmate.apl
REM apultra -c e_noise.bin e_noise.apl

pause
